package org.ow2.bonita.pvm.internal.wire.descriptor;

import org.ow2.bonita.pvm.env.Environment;
import org.ow2.bonita.pvm.internal.wire.Descriptor;
import org.ow2.bonita.pvm.internal.wire.WireContext;
import org.ow2.bonita.pvm.internal.wire.WireException;

public class ContextRefDescriptor extends AbstractDescriptor implements
    Descriptor {

  private static final long serialVersionUID = 1L;

  String contextName;

  public Object construct(WireContext wireContext) {
    if (contextName == null) {
      return wireContext;
    }
    Environment environment = Environment.getCurrent();
    if (environment == null) {
      throw new WireException("can't get context '" + contextName
          + "': no current environment");
    }
    return environment.getContext(contextName);
  }

  public String getContextName() {
    return contextName;
  }

  public void setContextName(String contextName) {
    this.contextName = contextName;
  }
}
